#const global FALSE 0
#const global TRUE 1
#const global LEFT 0
#const global TOP 1
#const global RIGHT 2
#const global BOTTOM 3


dim i
dim ret
dim Score
dim HighScore
sdim StrScore


#module


;ϐa,b
#deffunc Swap var a, var b
	c = a
	a = b
	b = c
	return

;lp``
#deffunc Quadrangle int x1, int y1, int x2, int y2
	line x1, y1, x2, y1
	line x1, y2, x2, y2
	line x1, y1, x1, y2
	line x2, y1, x2, y2
	return

;``
#deffunc Square int x1, int y1, int size
	line x1 - size / 2, y1 - size / 2, x1 + size / 2, y1 - size / 2
	line x1 - size / 2, y1 + size / 2, x1 + size / 2, y1 + size / 2
	line x1 - size / 2, y1 - size / 2, x1 - size / 2, y1 + size / 2
	line x1 + size / 2, y1 - size / 2, x1 + size / 2, y1 + size / 2
	return

;2_Ԃ̋
#defcfunc Distance double x1, double y1, double x2, double y2
	return absf(sqrt((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2)))

;_ƒZ`̏Փ
#defcfunc PointRectCollision int x1, int y1, int left1, int top1, int right1, int bottom1
    if left1 <= x1 & x1 <= right1 & top1 <= y1 & y1 <= bottom1 {
		return TRUE
    }
    else {
    	return FALSE
    }

;Z`ƒZ`̏Փ
#defcfunc RectRectCollision int left1, int top1, int right1, int bottom1, int left2, int top2, int right2, int bottom2
    if left1 < right2 & right1 > left2 & top1 < bottom2 & bottom1 > top2 {
		return TRUE
    }
    else {
    	return FALSE
    }

;Z`Œ˕Ԃ
#deffunc RectRebound var x1, var y1, var vx1, var vy1, int left1, int top1, int right1, int bottom1
	if x1 <= left1 {
		x1 = left1
		vx1 = -vx1
	}
	if x1 >= right1 {
		x1 = right1
		vx1 = -vx1
	}
	if y1 <= top1 {
		y1 = top1
		vy1 = -vy1
	}
	if y1 >= bottom1 {
		y1 = bottom1
		vy1 = -vy1
	}
	return

;BG\
#deffunc BgPut int id
	gmode 0
	pos 0, 0
	celput id
	return

;XvCg\
#deffunc _Sprite int id, int x, int y, double zoomx, double zoomy, double angle
	gmode 2
	pos x, y
	celput id,, zoomx, zoomy, angle
	return

;nCXRAǂݍ
#deffunc HighScoreLoad
	exist "HighScore.dat"
	if strsize = -1 {
		HighScore@ = 0
		bsave "HighScore.dat", HighScore@
	}
	else {
		bload "HighScore.dat", HighScore@
	}
	return

;nCXRAXV
#deffunc HighScoreUpdate
	if Score@ > HighScore@ {
		HighScore@ = Score@
		bsave "HighScore.dat", HighScore@
	}
	return

;nCXRA
#deffunc HighScoreInit
	HighScore@ = 0
	bsave "HighScore.dat", HighScore@
	return


#global


#define Sprite(%1=0, %2 = 0, %3 = 0, %4 = 1.0, %5 = 1.0, %6 = 0.0) _Sprite %1, %2, %3, %4, %5, %6

